package com.logicbig.example;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import java.util.Arrays;
import java.util.List;

public class ExampleMain2 {
    public static void main(String[] args) throws Exception {
        EntityManagerFactory emf =
                Persistence.createEntityManagerFactory("example-unit");
        try {
            persistEntity(emf);
            runNativeQuery(emf);
            loadEntity(emf);
        } finally {
            emf.close();
        }
    }

    private static void persistEntity(EntityManagerFactory emf) throws Exception {
        EntityManager em = emf.createEntityManager();
        Report report = new Report();
        report.setReportContent("a very big report....");
        //some dummy image
        report.setReportImage(new byte[]{1, 2, 3, 2, 1, 3, 3, 1, 5, 6});
        report.setSubReportContents(Arrays.asList("sub report 1....", "sub report 2...."));

        System.out.println("-- Persisting entity --");
        System.out.println(report);

        em.getTransaction().begin();
        em.persist(report);
        em.getTransaction().commit();
        em.close();
    }

    private static void runNativeQuery(EntityManagerFactory emf) {
        System.out.println("-- Native query --");
        EntityManager em = emf.createEntityManager();
        ExampleMain.nativeQuery(em, "Select * from REPORT");
        ExampleMain.nativeQuery(em, "Select * from SUB_REPORTS");
    }

    private static void loadEntity(EntityManagerFactory emf) {
        System.out.println("-- Loading entity --");
        EntityManager em = emf.createEntityManager();
        List<Report> entityAList = em.createQuery("Select t from Report t").getResultList();
        entityAList.forEach(System.out::println);
        em.close();
    }
}